
/*****************************************************************************************/
/******************************This is GoodTime.cpp***************************************/
/*****************************************************************************************/

#define STRICT

#include <windows.h>
#include <mmsystem.h>

#include "dos.h"
#include "time.h"

#define RTCAdrPort 0x70       /* defines for Real Time Clock ports*/
#define RTCDtaPort 0x71


int PASCAL WinMain(HINSTANCE,HINSTANCE,LPSTR,int);
int mycount;

/**************** Get Real time clock access functions ************/

unsigned char RTCRead(unsigned char adresse)
{ (void)outp(RTCAdrPort,adresse);
  return(inp(RTCDtaPort)); }
           
unsigned char RTCDt(unsigned char adresse)
{ if (!(RTCRead(11)&4))
      return((RTCRead(adresse)>>4)*10+(RTCRead(adresse)&15));
  else
	  return(RTCRead(adresse));
}




/* My callback function*/
void FAR CALLBACK pascal TimerCalled( HWND hWnd, UINT message, UINT idTimer, DWORD dwTime )
{ 		struct dosdate_t d;
		struct dostime_t t;
		struct date dd;
		struct time tt;

 
		/*mycount++; */
		t.hour=RTCDt(4);      tt.ti_hour=t.hour;          /* This does the job of restoring the GoodTime */
		t.minute=RTCDt(2);    tt.ti_min=t.minute;
		t.second=RTCDt(0);    tt.ti_sec=t.second;
		t.hsecond=99;         tt.ti_hund=99;
        _dos_settime(&t);
		settime(&tt);
        _dos_getdate(&d);                                      /* I don't know if calling both funtions is needed,*/
		d.day=RTCDt(7);                   dd.da_day=d.day;     /* but it works in that way, so I just let it go.*/
		d.month=RTCDt(8);                 dd.da_mon=d.month;
		d.year=(RTCDt(50)*100)+RTCDt(9);  dd.da_year=d.year;
		_dos_setdate(&d);
		setdate(&dd);
}




int PASCAL WinMain( HINSTANCE hinst, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow )
{   MSG msg;
    TIMERPROC lpProc;
    UINT timid;

	mycount=0;


    /* The next code line is my BIG problem...*/
	lpProc = (TIMERPROC) MakeProcInstance((FARPROC)TimerCalled, hinst);
	/* Error GOODTIME.CPP 78: Cannot convert 'void (pascal near*)(const HWND__ near*,unsigned int,unsigned int,unsigned long)' to 'void (pascal *)()' */
	/* Error GOODTIME.CPP 78: Type mismatch in parameter 1 in call to 'pascal MakeProcInstance(void (pascal *)(),const HINSTANCE__ near*)'            */

	timid=SetTimer(NULL , NULL , 1000, lpProc);

	while ((GetMessage(&msg, NULL, 0, 0))&&(mycount<10))
	  /* mycount is there to allow program exit after 10 executions. This won't appear */
	  /* in final code, but is only there for debugging purpose. */
		{ 
				TranslateMessage(&msg);     /* copied this from a Sounder.c program, but don't really know why... */
				DispatchMessage(&msg);
		}
	(void)KillTimer(0, timid); /* again, only for debug */
	(void)FreeProcInstance( (FARPROC) lpProc);
	return(msg.wParam);
}


